// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_building_map_msgs:msg/Lift.idl
// generated code does not contain a copyright notice

#ifndef RMF_BUILDING_MAP_MSGS__MSG__DETAIL__LIFT__TRAITS_HPP_
#define RMF_BUILDING_MAP_MSGS__MSG__DETAIL__LIFT__TRAITS_HPP_

#include "rmf_building_map_msgs/msg/detail/lift__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'doors'
#include "rmf_building_map_msgs/msg/detail/door__traits.hpp"
// Member 'wall_graph'
#include "rmf_building_map_msgs/msg/detail/graph__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_building_map_msgs::msg::Lift & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: levels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.levels.size() == 0) {
      out << "levels: []\n";
    } else {
      out << "levels:\n";
      for (auto item : msg.levels) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: doors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.doors.size() == 0) {
      out << "doors: []\n";
    } else {
      out << "doors:\n";
      for (auto item : msg.doors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: wall_graph
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wall_graph:\n";
    to_yaml(msg.wall_graph, out, indentation + 2);
  }

  // member: ref_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_x: ";
    value_to_yaml(msg.ref_x, out);
    out << "\n";
  }

  // member: ref_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_y: ";
    value_to_yaml(msg.ref_y, out);
    out << "\n";
  }

  // member: ref_yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_yaw: ";
    value_to_yaml(msg.ref_yaw, out);
    out << "\n";
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width: ";
    value_to_yaml(msg.width, out);
    out << "\n";
  }

  // member: depth
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "depth: ";
    value_to_yaml(msg.depth, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_building_map_msgs::msg::Lift & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_building_map_msgs::msg::Lift>()
{
  return "rmf_building_map_msgs::msg::Lift";
}

template<>
inline const char * name<rmf_building_map_msgs::msg::Lift>()
{
  return "rmf_building_map_msgs/msg/Lift";
}

template<>
struct has_fixed_size<rmf_building_map_msgs::msg::Lift>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_building_map_msgs::msg::Lift>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_building_map_msgs::msg::Lift>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_BUILDING_MAP_MSGS__MSG__DETAIL__LIFT__TRAITS_HPP_
